/*
 * Copyright (c) 1998-2008 TeamDev Ltd. All Rights Reserved.
 * Use is subject to license terms.
 */
package com.teamdev.xpcom.mozilla.demo;

import java.util.EventObject;

import com.teamdev.jxbrowser.WebBrowser;

public class CommandStateChangeEvent extends EventObject
{
    private boolean _isBackButton;

    private boolean _backButtonEnabled;

    private boolean _isForwardButton;

    private boolean _forwardButtonEnabled;

    private boolean _isStopButton;

    private boolean _stopButtonEnabled;

    private boolean _isRefreshButton;

    private boolean _refreshButtonEnabled;

    public CommandStateChangeEvent(WebBrowser browser)
    {
        super(browser);
    }

    public void setBackButton(boolean isStopButton, boolean stopButtonEnabled)
    {
        _isBackButton = isStopButton;
        _backButtonEnabled = stopButtonEnabled;
    }

    public void setForwardButton(boolean isStopButton, boolean stopButtonEnabled)
    {
        _isForwardButton = isStopButton;
        _forwardButtonEnabled = stopButtonEnabled;
    }

    public void setRefreshButton(boolean isStopButton, boolean stopButtonEnabled)
    {
        _isRefreshButton = isStopButton;
        _refreshButtonEnabled = stopButtonEnabled;
    }

    public void setStopButton(boolean isStopButton, boolean stopButtonEnabled)
    {
        _isStopButton = isStopButton;
        _stopButtonEnabled = stopButtonEnabled;
    }

    public WebBrowser getBrowser()
    {
        return (WebBrowser) getSource();
    }

    public boolean isBackButton()
    {
        return _isBackButton;
    }

    public boolean isForvardButton()
    {
        return _isForwardButton;
    }

    public boolean isRefreshButton()
    {
        return _isRefreshButton;
    }

    public boolean isStopButton()
    {
        return _isStopButton;
    }

    public boolean isBackButtonEnabled()
    {
        return _backButtonEnabled;
    }

    public boolean isForwardButtonEnabled()
    {
        return _forwardButtonEnabled;
    }

    public boolean isRefreshButtonEnabled()
    {
        return _refreshButtonEnabled;
    }

    public boolean isStopButtonEnabled()
    {
        return _stopButtonEnabled;
    }

    public String toString()
    {
        return "CommandStateChangeEvent: _isBackButton=" + _isBackButton + "; _backButtonEnabled=" + _backButtonEnabled
                + "; _isForwardButton=" + _isForwardButton + "; _forwardButtonEnabled=" + _forwardButtonEnabled
                + "; _isRefreshButton=" + _isRefreshButton + "; _refreshButtonEnabled=" + _refreshButtonEnabled
                + "; _isStopButton=" + _isStopButton + "; _stopButtonEnabled=" + _stopButtonEnabled;
    }
}
