/*
 * Copyright (c) 1998-2008 TeamDev Ltd. All Rights Reserved.
 * Use is subject to license terms.
 */
package com.teamdev.xpcom.mozilla.demo.components;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Insets;

import javax.swing.border.AbstractBorder;

public class LineBorder extends AbstractBorder
{
    public static final int HORISONTAL = 0;

    public static final int VERTICAL = 1;

    private int _type = HORISONTAL;

    public LineBorder()
    {
    }

    public LineBorder(int type)
    {
        _type = type;
    }

    public void paintBorder(Component c, Graphics g, int x, int y, int width, int height)
    {
        g.translate(x, y);

        if (_type == HORISONTAL)
        {
            int h = height - 1;

            g.setColor(Color.lightGray);
            g.drawLine(0, h - 1, width - 1, h - 1);

            g.setColor(Color.white);
            g.drawLine(1, h, width, h);
        }
        else if (_type == VERTICAL)
        {
            g.setColor(Color.lightGray);
            g.drawLine(0, 0, 0, height - 1);

            g.setColor(Color.white);
            g.drawLine(1, 1, 1, height);
        }

        g.translate(-x, -y);
    }

    public Insets getBorderInsets(Component c)
    {
        return new Insets(0, 0, 0, 0);
    }

    public boolean isBorderOpaque()
    {
        return true;
    }
}
