/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * d:/Mozilla/mozilla/toolkit/components/commandlines/public/nsICommandLineRunner.idl
 */

package org.mozilla.interfaces;

/**
 * Extension of nsICommandLine that allows for initialization of new command lines
 * and running the command line actions by processing the command line handlers.
 *
 * @status INTERNAL - This interface is not meant for use by embedders, and is
 *                    not intended to be frozen. If you are an embedder and need
 *                    functionality provided by this interface, talk to Benjamin
 *                    Smedberg <benjamin@smedbergs.us>.
 */
public interface nsICommandLineRunner extends nsICommandLine {

  String NS_ICOMMANDLINERUNNER_IID =
    "{c1f4cfbf-a41f-4628-aa6c-9fb914478af8}";

  /**
   * This method assumes a native character set, and is meant to be called
   * with the argc/argv passed to main(). Talk to bsmedberg if you need to
   * create a command line using other data. argv will not be altered in any
   * way.
   *
   * On Windows, the "native" character set is UTF-8, not the native codepage.
   *
   * @param workingDir The working directory for resolving file and URI paths.
   * @param state      The nsICommandLine.state flag.
   */
  void init(int argc, long argv, nsIFile workingDir, long state);

  /**
   * Set the windowContext parameter.
   */
  void setWindowContext(nsIDOMWindow aWindow);

  /**
   * Process the command-line handlers in the proper order, calling "handle()" on
   * each.
   *
   * @throws NS_ERROR_ABORT if any handler throws NS_ERROR_ABORT. All other errors
   *         thrown by handlers will be silently ignored.
   */
  void run();

  /**
   * Process and combine the help text provided by each command-line handler.
   */
  String getHelpText();

}