/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * d:/Mozilla/mozilla/content/base/public/nsIObjectLoadingContent.idl
 */

package org.mozilla.interfaces;

/**
 * This interface represents a content node that loads objects.
 */
public interface nsIObjectLoadingContent extends nsISupports {

  String NS_IOBJECTLOADINGCONTENT_IID =
    "{90ab443e-3e99-405e-88c9-9c42adaa3217}";

  long TYPE_LOADING = 0L;

  long TYPE_IMAGE = 1L;

  long TYPE_PLUGIN = 2L;

  long TYPE_DOCUMENT = 3L;

  long TYPE_NULL = 4L;

  /**
   * The actual mime type (the one we got back from the network
   * request) for the element.
   */
  String getActualType();

  /**
   * Gets the type of the content that's currently loaded. See
   * the constants above for the list of possible values.
   */
  long getDisplayedType();

  /**
   * Gets the content type that corresponds to the give MIME type.  See the
   * constants above for the list of possible values.  If nothing else fits,
   * TYPE_NULL will be returned.
   */
  long getContentTypeForMIMEType(String aMimeType);

  /**
   * Returns the plugin instance if it has already been instantiated. This
   * will never instantiate the plugin and so is safe to call even when
   * content script must not execute.
   */
  nsIPluginInstance getPluginInstance();

  /**
   * Makes sure that a frame for this object exists, and that the plugin is
   * instantiated. This method does nothing if the type is not #TYPE_PLUGIN.
   * There is no guarantee that there will be a frame after this method is
   * called; for example, the node may have a display:none style. If plugin
   * instantiation is possible, it will be done synchronously by this method,
   * and the plugin instance will be returned. A success return value does not
   * necessarily mean that the instance is nonnull.
   *
   * This is a noscript method because it is internal and will go away once
   * plugin loading moves to content.
   *
   * @note If there is an error instantiating the plugin, this method will
   * trigger fallback to replacement content, and the type will change (and
   * this method will return a failure code)
   */
  nsIPluginInstance ensureInstantiation();

  /**
   * Tells the content about an associated object frame.
   * This can be called multiple times for different frames.
   *
   * This is noscript because this is an internal method that will go away, and
   * because nsIObjectFrame is unscriptable.
   */
  void hasNewFrame(nsISupports aFrame);

}