/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * d:/Mozilla/mozilla/modules/plugin/base/public/nsPIPluginHost.idl
 */

package org.mozilla.interfaces;

public interface nsPIPluginHost extends nsISupports {

  String NS_PIPLUGINHOST_IID =
    "{75d8fcd7-06d1-4767-9022-7f8dacf48a68}";

  /**
  * To notify the plugin manager that the plugin created a script object 
  */
  void setIsScriptableInstance(nsIPluginInstance aInstance, boolean aScriptable);

  /**
  * This method parses post buffer to find out case insensitive "Content-length" string
  * and CR or LF some where after that, then it assumes there is http headers in
  * the input buffer and continue to search for end of headers (CRLFCRLF or LFLF).
  * It will *always malloc()* output buffer (caller is responsible to free it) 
  * if input buffer starts with LF, which comes from 4.x spec 
  * http://developer.netscape.com/docs/manuals/communicator/plugin/pgfn2.htm#1007754
  * "If no custom headers are required, simply add a blank
  * line ('\n') to the beginning of the file or buffer.",
  * it skips that '\n' and considers rest of the input buffer as data.
  * If "Content-length" string and end of headers is found 
  *   it substitutes single LF with CRLF in the headers, so the end of headers
  *   always will be CRLFCRLF (single CR in headers, if any, remain untouched)
  * else
  *   it puts "Content-length: "+size_of_data+CRLFCRLF at the beginning of the output buffer
  * and memcpy data to the output buffer 
  *
  * On failure outPostData and outPostDataLen will be set in 0.  
  * @param aInPostData      - the post data
  * @param aInPostDataLen   - the length aInPostData
  * @param aOutPostData     - the buffer
  * @param aOutPostDataLen  - the length of aOutPostData
  **/
  void parsePostBufferToFixHeaders(String aInPostData, long aInPostDataLen, String[] aOutPostData, long[] aOutPostDataLen);

  /**
  * To create tmp file with Content len header in, it will use by http POST
  */
  void createTmpFileToPost(String aPostDataURL, String[] aTmpFileName);

  /**
  *  Creates a new plugin native window object
  */
  void newPluginNativeWindow(long[] aPluginNativeWindow);

  /**
  *  Deletes plugin native window object created by NewPluginNativeWindow
  */
  void deletePluginNativeWindow(long aPluginNativeWindow);

  /**
   * Instantiate a "dummy" java plugin if a java plugin that supports
   * NPRuntime is installed. This plugin is used for exposing
   * window.java and window.Packages. If the java plugin supports
   * NPRuntime and instantiation was successful, aOwners instance will
   * be non-null, if not, it will be null.
   */
  void instantiateDummyJavaPlugin(nsIPluginInstanceOwner aOwner);

  /**
  * Get the plugin name for the plugin instance.
  */
  void getPluginName(nsIPluginInstance aInstance, String[] aPluginName);

}